/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.unterstuetzer.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag;
import de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragUK;

public abstract class AbstractEintragungslisteEintragDAO extends de.ivu.elect.jee.entity.AbstractDAO<EintragungslisteEintrag,
        de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragPK
    , EintragungslisteEintragUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractEintragungslisteEintragDAO.class);

  public AbstractEintragungslisteEintragDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public EintragungslisteEintrag findByPrimaryKey(
        de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected EintragungslisteEintrag findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(EintragungslisteEintrag.class, id);
  }



     /**
      * Name: MaxPositionNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT MAX(obj.position) FROM EintragungslisteEintrag obj WHERE obj.gueltigkeit NOT IN (?3) AND obj.eintragungsliste.wahlvorschlag = ?1 AND obj.eintragungsliste.nummer = ?2<br>
      * SQL: <br>
      */
     public java.lang.Long findByMaxPosition( @javax.annotation.Nonnull de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag,  @javax.annotation.Nonnull java.lang.Long eintragungslisteNummer,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragGueltigkeit> gueltigkeiten) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlagCheckedAndAttached =  checkAndAttach(wahlvorschlag, de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag.class, "wahlvorschlag"); ;
		  			  java.lang.Long eintragungslisteNummerCheckedAndAttached =  eintragungslisteNummer ;
		  			  java.util.Collection<de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragGueltigkeit> gueltigkeitenCheckedAndAttached =  gueltigkeiten ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("EINTRAGUNGSLISTE_EINTRAG.MaxPosition")
                              .setParameter(1, wahlvorschlagCheckedAndAttached)
                                        .setParameter(2, eintragungslisteNummerCheckedAndAttached)
                                        .setParameter(3, gueltigkeitenCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("EintragungslisteEintrag, findByMaxPosition - NonUniqueResultException, Parameter: "
           + ", wahlvorschlag:'"+wahlvorschlag+"'"
           + ", eintragungslisteNummer:'"+eintragungslisteNummer+"'"
           + ", gueltigkeiten:'"+gueltigkeiten+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByMaxPosition(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndWildcardNummerGroupedByEintragungslisteAndGueltigkeitNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT el.id, el.nummer, ele.gueltigkeit, COUNT(ele.id) FROM EintragungslisteEintrag ele JOIN ele.eintragungsliste el WHERE el.wahlvorschlag.gruppeImGebiet.gebiet.wahl = ?1 AND STR(el.nummer) LIKE ?2 GROUP BY el.id, el.nummer, ele.gueltigkeit<br>
      * SQL: <br>
      */
     public java.util.List<Object[]> findByWahlAndWildcardNummerGroupedByEintragungslisteAndGueltigkeit( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.lang.String nummer) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.lang.String nummerCheckedAndAttached =  nummer ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("EINTRAGUNGSLISTE_EINTRAG.WahlAndWildcardNummerGroupedByEintragungslisteAndGueltigkeit")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, nummerCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("EintragungslisteEintrag, findByWahlAndWildcardNummerGroupedByEintragungslisteAndGueltigkeit - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", nummer:'"+nummer+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndWildcardNummerGroupedByEintragungslisteAndGueltigkeit(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragUK uk,
        de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintrag findByUK(de.ivu.elect.business.unterstuetzer.entity.EintragungslisteEintragUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}